<template>
  <b-form @submit.prevent="submitForm" @reset="resetForm" class="row">
    <b-form-group
        class="col"
        id="input-group-1"
        label="Количество записей"
        label-for="input-1"
    >
      <b-form-input
          id="input-1"
          v-model="rowCount"
          type="number"
          placeholder="Количество записей"
          required
      ></b-form-input>
    </b-form-group>
    <b-form-group
        class="col"
        id="input-group-2"
        label="Количество записей на странице"
        label-for="input-2"
    >
      <b-form-input
          id="input-2"
          v-model="rowPerPage"
          type="number"
          placeholder="Количество записей на странице"
          required
      ></b-form-input>
    </b-form-group>
    <b-form-group
        class="col"
        id="input-group-3"
        label="Значения"
        label-for="input-3"
    >
      <b-form-input
          id="input-3"
          v-model="values"
          placeholder="Введите значения через запятую"
          required
      ></b-form-input>
    </b-form-group>
    <b-button type="submit" variant="primary">Применить</b-button>
    <b-button type="reset" variant="danger">Сбросить</b-button>
  </b-form>
</template>

<script>
export default {
  name: "Form",
  data: ()=>({
    rowCount: undefined,
    rowPerPage: undefined,
    values: '',
  }),
  watch: {
    rowPerPage(newVal) {
      this.$emit('setRowPerPage', newVal)
    }
  },
  methods: {
    submitForm() {
      let json = [];
      for (let i = 0; i < this.rowCount; i++) {
        const row = {
          id: i + 1,
          title: `name${i + 1}`,
          rand: this.getRandomValue(),
        }
        json.push(row);
      }
      this.$emit('setTableData', json)
    },
    resetForm() {
      this.$emit('setTableData', [])
    },
    getRandomValue() {
      const splitValues = this.values.split(',');
      const maxIndex = splitValues.length;
      const randIndex = this.getRandomInt(maxIndex);
      return splitValues[randIndex].trim();
    },
    getRandomInt(max) {
      return Math.floor(Math.random() * max);
    }
  }
}
</script>

<style scoped>

</style>
